//+------------------------------------------------------------------
//| original by Metatrader4 Code by jjk2.                            
//| modified by mladen
//+------------------------------------------------------------------
#property copyright "Based on MBA Thesis from Simon Fraser University written by C.E. ALDEA."
#property link      ""
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  clrLimeGreen
#property indicator_color2  clrOrange
#property indicator_color3  clrOrange
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  3
#property strict

enum enStoMode
{
   sto_main, // Use main stochastic value
   sto_sig   // Use stochastic signal value
};
extern int            Kperiod         = 9;        // Stochastic K Period
extern int            Dperiod         = 6;        // Stochastic D Period
extern int            slowing         = 2;        // Stochastic Slowing
extern ENUM_MA_METHOD method_stoch    = MODE_SMA; // Stochastic MaMethod
extern ENUM_STO_PRICE price_field     = 1;        // Stochastic Price High/Low or Close
extern enStoMode      mode            = sto_sig;  // Stochastic mode stochastic/stochastic signal
extern int            period_rsi      = 9;        // Rsi Period
extern int            period_momentum = 9;        // Momentum Period
extern ENUM_APPLIED_PRICE Price       = PRICE_CLOSE; // Price for RSI and momentum
extern double         Sensitivity     = 4;        // Sensivity Factor
extern double         StepSize        = 5;        // Constant Step Size
extern bool           alertsOn        = false;          // Turn alerts on?
extern bool           alertsOnCurrent = true;           // Alerts on current (still opened) bar?
extern bool           alertsMessage   = true;           // Alerts should display a message?
extern bool           alertsSound     = false;          // Alerts should play a sound?
extern bool           alertsEmail     = false;          // Alerts should send an email?


double skwan[];
double kwan[];
double kwanda[];
double kwandb[];
double temp[];
double trend[];

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,skwan);
   SetIndexBuffer(1,kwanda);
   SetIndexBuffer(2,kwandb);
   SetIndexBuffer(3,kwan);
   SetIndexBuffer(4,temp);
   SetIndexBuffer(5,trend);
               
   IndicatorShortName(" ZigZag BETA Current value calculated by indicator:");
return(0);
}
int deinit(){ return(0);}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      if (trend[limit]==-1) CleanPoint(limit,kwanda,kwandb);
      for (i=limit; i>= 0; i--)
      {
         double Stoch  = iStochastic(NULL,0,Kperiod,Dperiod,slowing,method_stoch,price_field,mode,i);
         double RSI    = iRSI(NULL,0,period_rsi,Price,i);
         double moment = iMomentum(NULL,0,period_momentum,Price,i);
         if (moment!=0)
               temp[i] = Stoch*RSI/moment;
         else  temp[i] = 0;       
      }
      for (i=limit; i>= 0; i--)
      {
         kwan[i]   = iMAOnArray(temp,0,2,0,MODE_SMA,i);
         kwanda[i] = EMPTY_VALUE;
         kwandb[i] = EMPTY_VALUE;
         skwan[i]  = iStepMa(Sensitivity,StepSize,0.5,kwan[i],kwan[i],kwan[i],i);
         if (i<(Bars-1)) { if (trend[i]==-1) PlotPoint(i,kwanda,kwandb,skwan); }
      }
   manageAlerts();
   return(0);
}
   
   
//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double workStep[][3];
#define _smin   0
#define _smax   1
#define _trend  2

double iStepMa(double sensitivity, double stepSize, double stepMulti, double phigh, double plow, double pprice, int r)
{
   if (ArrayRange(workStep,0)!=Bars) ArrayResize(workStep,Bars);
   if (sensitivity == 0) sensitivity = 0.0001; r = Bars-r-1;
   if (stepSize    == 0) stepSize    = 0.0001;
      double result = 0; 
	   double size   = sensitivity*stepSize;

      //
      //
      //
      //
      //
      
      if (r==0)
      {
         workStep[r][_smax]  = phigh+2.0*size*stepMulti;
         workStep[r][_smin]  = plow -2.0*size*stepMulti;
         workStep[r][_trend] = 0;
         return(pprice);
      }

      //
      //
      //
      //
      //
      
      workStep[r][_smax]  = phigh+2.0*size*stepMulti;
      workStep[r][_smin]  = plow -2.0*size*stepMulti;
      workStep[r][_trend] = workStep[r-1][_trend];
            if (pprice>workStep[r-1][_smax]) workStep[r][_trend] =  1;
            if (pprice<workStep[r-1][_smin]) workStep[r][_trend] = -1;
            if (workStep[r][_trend] ==  1) { if (workStep[r][_smin] < workStep[r-1][_smin]) workStep[r][_smin]=workStep[r-1][_smin]; result = workStep[r][_smin]+size*stepMulti; }
            if (workStep[r][_trend] == -1) { if (workStep[r][_smax] > workStep[r-1][_smax]) workStep[r][_smax]=workStep[r-1][_smax]; result = workStep[r][_smax]-size*stepMulti; }
      trend[Bars-r-1] = workStep[r][_trend]; 

   return(result); 
} 

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] ==  1) doAlert(time1,mess1,whichBar," Step Kwan sloping up");
            if (trend[whichBar] == -1) doAlert(time1,mess1,whichBar," Step Kwan sloping down");
         }            
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Step Kwan "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}